VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Pulse Width Measurement with KPCI-3100 Series"
   ClientHeight    =   4545
   ClientLeft      =   1740
   ClientTop       =   1590
   ClientWidth     =   8145
   Height          =   4950
   Left            =   1680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   8145
   Top             =   1245
   Width           =   8265
   Begin VB.TextBox Text1 
      Height          =   495
      Left            =   2640
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   1200
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Measure"
      Height          =   735
      Left            =   480
      TabIndex        =   0
      Top             =   1080
      Width           =   1695
   End
   Begin VB.Label Label4 
      Caption         =   $"3100pw.frx":0000
      Height          =   975
      Left            =   600
      TabIndex        =   5
      Top             =   3240
      Width           =   5895
   End
   Begin VB.Label Label3 
      Caption         =   $"3100pw.frx":0115
      Height          =   735
      Left            =   600
      TabIndex        =   4
      Top             =   2160
      Width           =   6015
   End
   Begin VB.Label Label2 
      Caption         =   " Pulse Width (msec)"
      Height          =   255
      Left            =   2640
      TabIndex        =   3
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H000000FF&
      Caption         =   " KEITHLEY "
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   360
      Left            =   600
      TabIndex        =   2
      Top             =   240
      Width           =   1665
   End
   Begin DlsrLib.DriverLINXSR DriverLINXSR3 
      Left            =   6120
      Top             =   840
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin DlsrLib.DriverLINXSR DriverLINXSR2 
      Left            =   5400
      Top             =   840
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin DlsrLib.DriverLINXSR DriverLINXSR1 
      Left            =   6840
      Top             =   840
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Dim di As Integer
Private Sub Command1_Click()
With DriverLINXSR3 'start 1 millisecond time base on counter 0
.Req_op = DL_START
.Req_mode = DL_POLLED
.Req_subsystem = DL_CT
.Evt_Tim_type = DL_RATEEVENT
.Evt_Tim_rateChannel = 0
.Evt_Tim_rateClock = DL_INTERNAL1
.Evt_Tim_rateGate = DL_DISABLED
.Evt_Tim_rateMode = DL_SQWAVE
.Evt_Tim_ratePeriod = .DLSecs2Tics(DL_INTERNAL1, 0.001)
.Refresh
End With
showmessage DriverLINXSR3

' Since there will be no message notification
' when the Pulse Width measurement is finished
' we use a digital input to monitor the state of
' the gate signal applied to both PA0 and Gate of
' Counter 1
With DriverLINXSR2 'Read digital input on port A
.Req_op = DL_START
.Req_subsystem = DL_DI
.Req_mode = DL_POLLED
.Sel_chan_N = 1
.Sel_chan_start = 0
.Evt_Tim_type = DL_NULLEVENT
End With

Do
DriverLINXSR2.Refresh
di = DriverLINXSR2.Res_Sta_ioValue
Loop Until (di And 1) = 1

'Wait until the gating signal goes from high to low
'before starting pulse width counter

Do
DriverLINXSR2.Refresh
di = DriverLINXSR2.Res_Sta_ioValue
Loop Until (di And 1) = 0
'Wait until gate low, then start measurement

With DriverLINXSR1
.Req_op = DL_START
.Req_mode = DL_POLLED
.Req_subsystem = DL_CT
.Evt_Tim_type = DL_RATEEVENT
.Evt_Tim_rateChannel = 1
.Evt_Tim_rateClock = DL_TCNm1      'Use output of counter 0 as clock source
.Evt_Tim_rateGate = HILEVELGATEN   ' Active High gate
.Evt_Tim_rateMode = DL_PULSEWD     ' Pulse Width mode
.Evt_Tim_ratePulses = 0
.Evt_Tim_rateOnCount = 0
.Evt_Tim_ratePeriod = 0
.Refresh
End With
showmessage DriverLINXSR1

Do
DriverLINXSR2.Refresh
di = DriverLINXSR2.Res_Sta_ioValue
Loop Until (di And 1) = 1 'Wait until gate goes high again

Do
DriverLINXSR2.Refresh
di = DriverLINXSR2.Res_Sta_ioValue
Loop Until (di And 1) = 0
'Wait until gate goes low again, then read counter

With DriverLINXSR1 'read counter
.Req_op = DL_STATUS
.Refresh
Text1.Text = .Res_Tim_count
.Req_op = DL_STOP
.Refresh
End With
With DriverLINXSR3 'stop the square wave source
.Req_op = DL_STOP
.Refresh
End With
End Sub

Private Sub Form_Load()
With DriverLINXSR1
.Req_DLL_name = "kpci3100"
.Req_device = 0
.Req_subsystem = DL_DEVICE
.Req_mode = DL_OTHER
.Req_op = DL_INITIALIZE
.Refresh
End With
showmessage DriverLINXSR1
With DriverLINXSR2 'configure port A as input to use bit 0
.Req_DLL_name = DriverLINXSR1.Req_DLL_name
.Req_device = DriverLINXSR1.Req_device
.Req_op = DL_CONFIGURE
.Req_subsystem = DL_DI
.Req_mode = DL_OTHER
.Evt_Tim_dioChannel = 0
.Evt_Tim_dioMode = DL_DIO_BASIC
.Evt_Tim_type = DL_DIOSETUP
.Refresh
End With
showmessage DriverLINXSR2
With DriverLINXSR3
.Req_DLL_name = DriverLINXSR2.Req_DLL_name
.Req_device = DriverLINXSR2.Req_device
End With
End Sub


Sub showmessage(sr As Control)
sr.Req_op = DL_MESSAGEBOX
sr.Refresh
End Sub
